//
//  animation.vsh
//  SplashtopRemote
//
//  Created by Splashtop on 12/07/11.
//  Copyright 2011 Splashtop. All rights reserved.
//

attribute vec2 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_transform;
attribute vec4 a_reference;
attribute vec3 a_parameter;
attribute vec2 a_backingSize;

varying   vec2 v_texCoord;

void main()
{
    vec2  position;
    vec4  transform;
    float step;
    
    // Animation
    if (a_parameter.x != 0.0) {
        step = a_parameter.x / a_parameter.y;
        transform = a_transform - a_reference;
        transform = transform * step;
        transform = transform + a_reference;
    } else {
        transform = a_transform;
    }
    
    // Screen scale factor
    transform = transform * a_parameter[2];
    
    // Transform
    position = a_position * transform.z;
    position = position + transform.xy;
    
    // Orthogonal
    gl_Position = vec4( position.x * (2.0 / a_backingSize.x) - 1.0,
                       -position.y * (2.0 / a_backingSize.y) + 1.0,
                       0.0,
                       1.0);
    
    v_texCoord = a_texCoord;
}
